#include<iostream>
#include<typeinfo>
#include"STL/extend/skiplist.h"
#include<functional>
#include<future>
#include<chrono>
#include<random>
int fun(int a,int b)
{
    return a+b;
}

int main()
{
    nanxing_extend::skipList<int,int> test{15};
    int random[1024];
    std::mt19937 rnd(std::chrono::system_clock::now().time_since_epoch().count());
    for(auto& i:random)
    {
        i=static_cast<unsigned int>(rnd());
    }
    std::chrono::high_resolution_clock::time_point tp1 = std::chrono::high_resolution_clock::now();
    
    for(int i=0;i<200000;i++)
    {
        auto get=test.insert(random[i%1024],i);
    }

    std::chrono::high_resolution_clock::time_point tp2 = std::chrono::high_resolution_clock::now();
    std::chrono::duration<size_t, std::nano> dur = tp2 - tp1;
    test.Print();
    std::cout << "1 被计时代码耗时：" << std::chrono::duration_cast<std::chrono::nanoseconds>(dur).count() << " 纳秒" << std::endl;
    std::cout << "2 被计时代码耗时：" << std::chrono::duration_cast<std::chrono::microseconds>(dur).count() << " 微妙" << std::endl;
    std::cout << "3 被计时代码耗时：" << std::chrono::duration_cast<std::chrono::milliseconds>(dur).count() << " 毫秒" << std::endl;
    std::cout << "4 被计时代码耗时：" << std::chrono::duration_cast<std::chrono::seconds>(dur).count() << " 秒钟" << std::endl;
    std::cout << "5 被计时代码耗时：" << std::chrono::duration_cast<std::chrono::minutes>(dur).count() << " 分钟" << std::endl;
    std::cout << "6 被计时代码耗时：" << std::chrono::duration_cast<std::chrono::hours>(dur).count() << " 小时" << std::endl;

}